/* server test  */
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/wait.h>
#include <string.h>
#include <errno.h>

pid_t	spid,cpid1,cpid2;

int main()
{
  char buffer[512];
  char out[512];
  int lgt,status,res;

  spid=getpid();
  sprintf(out,"\nServer (%d) startet\n",spid);
  write(2,out,strlen(out));

  for (;;) {
     write(1,"\n: ",3);
     if (( lgt=read(0,buffer,512)) <=0) {
        sprintf(out,"\nServer ended\n");
        write(2,out,strlen(out));
        exit(-1);
     }
     if (lgt <= 1)  goto wait;
     if ( (cpid1 = fork()) < 0) {
          sprintf(out,"\nserver can't fork\n");
          write(2,out,strlen(out));
          exit(-2);
     }
     if (cpid1 == 0) {	
        /* child 1 */
        cpid1=getpid();
        sprintf(out,"\n   Client 1 (%d) start.",cpid1);
        write(2,out,strlen(out));
        if ( (cpid2 = fork()) < 0) {
             sprintf(out,"\n   Client 1 (%d) can't fork",cpid1);
             write(2,out,strlen(out));
             exit(-2);
        }
        if (cpid2 == 0 ) {
            /* child 2 */
            cpid2=getpid();
            sprintf(out,"\n      Client 2 (%d(%d)) start.\n",cpid2,cpid1);
            write(2,out,strlen(out));
            sleep(5);
            res='a'-buffer[0];
            sprintf(out,"\n      Client 2 (%d(%d)) end with %d.",cpid2,cpid1,res);
            write(2,out,strlen(out));
            exit(res);
        }
        /* child 1 nach fork */
        res=wait(&status);
        if (res < 0) {
              fprintf(stderr,"\n   res: %d, errno: %d, Text: %s",res,errno,strerror(errno));
        }
        sprintf(out,"\n   Child 1 (%d) nach wait auf Client 2 (%d). PID: %d, Status: %d\n",cpid1,cpid2,res,status>>8);
        write(2,out,strlen(out));
        exit(status>>8);
       
     }  
     /* Server nach fork */
     wait: sprintf(out,"\nServer (%d) start client %d",spid,cpid1);
     write(2,out,strlen(out));
     while ((res=waitpid(-1,&status,WNOHANG)) >0) {
        sprintf(out,"\nServer wait successfull. PID: %d, Status: %d",res,status>>8);
        write(2,out,strlen(out));
     }
     sprintf(out,"\nServer wait failed. PID: %d, errno: %d, msg: %s",res,errno>>8,strerror(errno));
     write(2,out,strlen(out));
  }
  exit(0);
}
